/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignStrategyComChannel type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignStrategyComChannel{}

// CampaignStrategyComChannel struct for CampaignStrategyComChannel
type CampaignStrategyComChannel struct {
	TypePreference []string `json:"type_preference,omitempty"`
}

// NewCampaignStrategyComChannel instantiates a new CampaignStrategyComChannel object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignStrategyComChannel() *CampaignStrategyComChannel {
	this := CampaignStrategyComChannel{}
	return &this
}

// NewCampaignStrategyComChannelWithDefaults instantiates a new CampaignStrategyComChannel object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignStrategyComChannelWithDefaults() *CampaignStrategyComChannel {
	this := CampaignStrategyComChannel{}
	return &this
}

// GetTypePreference returns the TypePreference field value if set, zero value otherwise.
func (o *CampaignStrategyComChannel) GetTypePreference() []string {
	if o == nil || IsNil(o.TypePreference) {
		var ret []string
		return ret
	}
	return o.TypePreference
}

// GetTypePreferenceOk returns a tuple with the TypePreference field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignStrategyComChannel) GetTypePreferenceOk() ([]string, bool) {
	if o == nil || IsNil(o.TypePreference) {
		return nil, false
	}
	return o.TypePreference, true
}

// HasTypePreference returns a boolean if a field has been set.
func (o *CampaignStrategyComChannel) HasTypePreference() bool {
	if o != nil && !IsNil(o.TypePreference) {
		return true
	}

	return false
}

// SetTypePreference gets a reference to the given []string and assigns it to the TypePreference field.
func (o *CampaignStrategyComChannel) SetTypePreference(v []string) {
	o.TypePreference = v
}

func (o CampaignStrategyComChannel) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignStrategyComChannel) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.TypePreference) {
		toSerialize["type_preference"] = o.TypePreference
	}
	return toSerialize, nil
}

type NullableCampaignStrategyComChannel struct {
	value *CampaignStrategyComChannel
	isSet bool
}

func (v NullableCampaignStrategyComChannel) Get() *CampaignStrategyComChannel {
	return v.value
}

func (v *NullableCampaignStrategyComChannel) Set(val *CampaignStrategyComChannel) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignStrategyComChannel) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignStrategyComChannel) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignStrategyComChannel(val *CampaignStrategyComChannel) *NullableCampaignStrategyComChannel {
	return &NullableCampaignStrategyComChannel{value: val, isSet: true}
}

func (v NullableCampaignStrategyComChannel) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignStrategyComChannel) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


